Unit SF74R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure SF74R(X :Real; N1 :Integer; EPS :Real; var S :Boolean;
                var T :Array of Real; var T1 :Array of Real);

implementation

procedure SF74R(X :Real; N1 :Integer; EPS :Real; var S :Boolean;
                var T :Array of Real; var T1 :Array of Real);
var
D,IP,IP1,IP2,IZ3,IZ4,IZ6,K,K1,K2,M,N,P :Integer;
C,ERR,R0,R1,R2,SUM,Y,Z,Z0,Z1,Z2,Z5,Z7 :Real;
F :Boolean;
const
SYS053 :Real = 3.4E38;
SYS055 :Real = 1.2E-38;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320;
begin
N  := N1 - 1;
if ( X ) < 0
 then goto _30
 else if ( X ) > 0
       then goto _30
       else goto _10;
_10:
T[0] := 1.0;
for P:=2 to N1 do
 begin
  T[P-1] := 0.0;
_20:
 end;
goto _320;
_30:
Z0  := Exp(-X) - SYS055;
if ( Z0 ) < 0
 then goto _40
 else if ( Z0 ) > 0
       then goto _50
       else goto _50;
_40:
S  := False;
_50:
if ( S ) 
 then goto _60;
C  := 1.0;
goto _70;
_60:
C  := Exp(-X);
_70:
Y  := Abs(X);
Z1  := Y - 1.0;
if ( Z1 ) < 0
 then goto _80
 else if ( Z1 ) > 0
       then goto _90
       else goto _80;
_80:
M  := 10;
D  := 3;
goto _120;
_90:
Z2  := Y - 10.0;
if ( Z2 ) < 0
 then goto _100
 else if ( Z2 ) > 0
       then goto _110
       else goto _100;
_100:
M  := Trunc( 10 + 1.5*Y );
D  := Trunc( 3 + 0.5*Y );
goto _120;
_110:
M  := Trunc( 25 + 0.5*Y );
D  := Trunc( 0.25*Y + 100.0/Y );
_120:
IZ3  := M - N;
if ( IZ3 ) < 0
 then goto _130
 else if ( IZ3 ) > 0
       then goto _140
       else goto _130;
_130:
M  := N + D;
_140:
F  := False;
_150:
SUM  := 0.0;
R0  := 0.0;
R1  := 1.0;
Z  := SYS053/4.0/M*Y;
for IP1:=1 to M do
 begin
  IP  := M - IP1 + 1;
  IP2  := IP - 1;
  P  := Trunc( (IP) );
  IZ4  := N + 1 - IP;
  if ( IZ4 ) < 0
   then goto _160
   else if ( IZ4 ) > 0
         then goto _170
         else goto _170;
_160:
  R2  := 2.0*P/X*R1 + R0;
  T[N1-1] := R2;
  goto _180;
_170:
  R2  := 2.0*P/X*R1 + R0;
  T[IP-1] := R2;
_180:
  Z5  := Z - Abs(R2);
  if ( Z5 ) < 0
   then goto _190
   else if ( Z5 ) > 0
         then goto _210
         else goto _210;
_190:
  R1  := R1/Z;
  R2  := R2/Z;
  SUM  := SUM/Z;
  for K1:=IP2 to N do
   begin
    K  := IP2 + N - K1;
    K2  := K + 1;
    T[K2-1] := T[K2-1]/Z;
_200:
   end;
_210:
  IZ6  := IP - 1;
  if ( IZ6 ) < 0
   then goto _230
   else if ( IZ6 ) > 0
         then goto _230
         else goto _220;
_220:
  SUM  := SUM + R2;
  goto _240;
_230:
  SUM  := SUM + 2.0*R2;
_240:
  R0  := R1;
  R1  := R2;
_250:
 end;
SUM  := SUM*C;
for IP1:=1 to N1 do
 begin
  T[IP1-1] := T[IP1-1]/SUM;
_260:
 end;
if ( F ) 
 then goto _270;
goto _300;
_270:
ERR  := Abs(T[N1-1] - T1[N1-1]);
Z7  := ERR - EPS*Abs(T[N1-1]);
if ( Z7 ) < 0
 then goto _280
 else if ( Z7 ) > 0
       then goto _290
       else goto _280;
_280:
goto _320;
_290:
_300:
F  := True;
for IP:=1 to N1 do
 begin
  T1[IP-1] := T[IP-1];
_310:
 end;
M  := M + D;
goto _150;
_320:
end;

end.
